#ifndef _WEIGHTED_AVERAGE_H_
#define _WEIGHTED_AVERAGE_H_

#include <vector>
#include <fstream>
#include "types.h"

using namespace std;

class WeightedAverage
{
	const static int scalepower = 6+8/**/;
	const static int scale = 64*256/**/;
	PVideoFrame result;

	//int width, height;
	int length;
	vector<PVideoFrame> source;
	vector<int> scaledweight;

	void averageplane(int plane, IScriptEnvironment* env);
	void averageplane_P4(int plane, IScriptEnvironment* env);
public:
	WeightedAverage(PClip sourceclip, const DisplacedVector<double> &weight, IScriptEnvironment* env, VideoInfo vi);
	operator PVideoFrame() const {return result;}
};


#endif
