#include <map>
#include <string>
extern std::map<std::string, int> calls;
//	ofstream output("calls.txt");
//	for(map<string, int>::const_iterator i = calls.begin(); i != calls.end(); ++i)
//		output<<i-> second << "\t" <<i-> first<< "\n";



class MeasureCycles
{
	int begincycles;
	int endcycles;
	int scale;
	unsigned int cycles();
public:
	MeasureCycles(int _scale=1000): scale(_scale) {begincycles = cycles();}
	void reset()
	{
		begincycles  = cycles ();		
	}
	int mark()
	{
		endcycles = cycles();
		int cyclesused=endcycles-begincycles;
	//	loga	<<cyclesused <<"\t"<< float (cyclesused)/scale<<"\n" ;
	//	loga.flush ();
		begincycles = endcycles;
		return cyclesused;
	}
	operator int() {return mark();}
};

inline unsigned int MeasureCycles::cycles ()
{
	int result;
	__asm
    {
		xor ebx,ebx
		rdtsc
		xor ebx,ebx
		mov	[result], eax
	}
	return result;
}

#include <fstream>
#include <ctime>
//class TimeFile
//{
//	std::clock_t start;
//	std::ofstream file;
//public:
//	TimeFile() : file("Timed events.txt") {start = std::clock();}
//	void reset() {start = std::clock();}
//	double elapsed() {return double(std::clock() - start)/CLK_TCK;}
//	//double elapsed() {return int(std::clock());}
//  //int TimeFile::cycles ();
//	void operator<<(std::string s) {file << elapsed() << ":\t" << s << "\n";}
//	void operator<<(const char *s) {file << elapsed() << ":\t" << s << "\n";}
//	void operator<<(int i) {file << elapsed() << ":\t" << i << "\n";}
//	void operator<<(double d) {file << elapsed() << ":\t" << d << "\n";}
//	void operator<<(void *p) {file << elapsed() << ":\t" << p << "\n";}
//};
//extern TimeFile timed;
