#ifndef _APPLY_H_
#define _APPLY_H_

#include "blend.h"
#include <vector>
using namespace std;

class ForwardBlend : public GenericVideoFilter 
{   
	/*const*/ Blend &blend;
public:
	ForwardBlend(PClip _child, /*const*/ Blend &_blend, IScriptEnvironment* env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

class ReverseBlend : public GenericVideoFilter 
{   
	/*const*/ Blend &blend;
	int blendedframecount, originalframecount;

public:
	ReverseBlend(PClip _child, /*const*/ Blend &_blend, IScriptEnvironment* env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

#endif
